// T34preCat_OffEst.sce
// PREDICTION WITH DISCRETE MODEL (OFF-LINE), UNKNOWN PARAMETERS
// Experiments
// Change: - length of prediction
//         - uncertainty of the simulated model
//         - imput signal (effect on estimation)
// -------------------------------------------------------------------
exec("ScIntro.sce",-1),mode(0)

nd=50;                             // number of data
np=5;                              // length of prediction
th1=[0.8 0.1 0.4 0.7]';            // parameters for simulation (for y=1)
th=[th1 1-th1];                    // all parameters
u=(rand(1,nd)>.3)+1;               // input
y=ones(1,nd);

// SIMULATION
for t=2:nd
  i=2*(u(t)-1)+y(t-1);             // row of the table
  y(t)=sum(rand(1,1,'u')>cumsum(th(i,:)))+1;  // output generation
end

// ESTIMATION
nu=zeros(4,2);
for t=2:nd
  i=2*(u(t)-1)+y(t-1);             // row of the table
  nu(i,y(t))=nu(i,y(t))+1;         // statistics update
end
Eth=nu./(sum(nu,2)*ones(1,2));     // estimate of parameters

// PREDICTION
yy(1)=1;                           // fictitious predicted output
for t=2:(nd-np)
  i=2*(u(t)-1)+y(t-1);             // row of the table
  yy=sum(rand(1,1,'u')>cumsum(th(i,:)))+1; // prediction generation
  for j=1:np
    i=2*(u(t+j)-1)+yy;             // row of the table
    yy=sum(rand(1,1,'u')>cumsum(th(i,:)))+1; // prediction generation
  end
  yp(t+np)=yy;                     // np-step predction
end

// Results
disp(' Simulated parameters')
disp(th)
disp(' Estimated parameters')
disp(Eth)

s=(np+3):nd;
plot(s,y(s),'.:',s,yp(s),'rx')
set(gcf(),'position',[300 100 500 400])
set(gca(),"data_bounds",[0 nd+1 .9 2.1])
legend('output','prediction');
title(string(np)+'-steps ahead prediction')

Wrong=sum(y(:)~=yp(:))
From=nd
